#include <nds.h>
#include "mplus_font_10x10.h"
#include "mplus_font_10x10alpha.h"

// FrameBuffer p

void draw_font(int x, int y, int width, u16* buffer, u16 code, u16 color)
{
	int i, j;
	u16 bit;
	u16 block;
	
	buffer += y * width + x;
	
	// 1 oCg
	if ( code < 0x100 ) {
		u8 block8;
		u8 bit8;
		
		for ( i = 0; i < 13; i++ ) {
			u16* line = buffer + (width * i);
			bit8 = 0x80;
			block8 = FONT_MPLUS_10x10A[code][i];
		
			for ( j = 0; j < 7; j++ ) {
				if ( (block8 & bit8) > 0 ) {
					*(line + j) = color;
				}
				bit8 = bit8 >> 1;
			}
		}
	} else {
	// 2oCg
		u16 *font_set;
		
		if (code >= 0x8100 && code <= 0x9F00) {
			font_set = (u16 *)FONT_MPLUS_10x10;
			code -= 0x8100;
		}
		else if (code >= 0xE000 && code <= 0xFC00) {
			font_set = (u16 *)FONT_MPLUS_10x10_2;
			code -= 0xE000;
		}
		else {
			return;
		}
		
		
		for ( i = 0; i < 11; i++ ) {
			uint16* line = buffer + (width * i);
			bit = 0x8000;
			block = *(font_set + code * 11 + i);
		
			for ( j = 0; j < 11; j++ ) {
				if ( (block & bit) > 0 ) {
					*(line + j) = color;
				}
				bit = bit >> 1;
			}
		}
	}
}


// I[ \0 w肳ꂽʒuɕ\iShift-JIS pj
void printString(int x, int y, int width, u16* buffer, char *string, u16 color)
{
	int i;
	int dx = 0;
	u16 current;
	u8 t;
	
	
	for ( i = 0; ; i++ ) {
		t = string[i];
		
		// I[
		if ( t == '\0' ) {
			break;
		}
		
		// r̉s
		if ( t == '\r' ) {
			if ( string[i + 1] == '\n' ) {
				i++;
				x = 0;
				dx = 0;
				y += 11;
				continue;
			}
		}
		
		// s
		if ( t == '\n' ) {
			x = 0;
			dx = 0;
			y += 11;
			continue;
		}
		
		// Shift-JIS  1 oCgڂꍇ
		if ( (t >= 0x81 && t <= 0x9F) || (t >= 0xE0 && t <= 0xEF) || (t >= 0xF0 && t <= 0xFC) ) {
			current = (t << 8) | string[i + 1];
			draw_font(x + dx, y, width, buffer, current, color);
			i++;
			dx += 10;
		} else {
			draw_font(x + dx, y, width, buffer, t, color);
			dx += 6;
		}
		
		
		if ( x + dx > width - 11 ) {
			x = 0;
			dx = 0;
			y += 10;
		}
		
	}
}

static int y = 0;

void scroll_next()
{
	if ( y > 181 ) {
		y = 181;
		
		int i;
		//u16 black = RGB15(0, 0, 0);
		for ( i = 0; i <= 256 * 182; i++ ) {
			*(VRAM_A + i) = *(VRAM_A + i + (256 * 10));
		}
		for ( i = 256 * 182; i <= 256 * 192; i++ ) {
			*(VRAM_A + i) = 0;
		}
		
	}

}

// I[ \0 w肳ꂽʒuɕ\iShift-JIS pj
// Ōɏo͂CL
void echo(const char *string)
{
	int x = 0;
	int i;
	int dx = 0;
	
	u16 color = RGB15(31, 31, 31);
	u16 current;
	u8 t;
	
	scroll_next();
	
	for ( i = 0; ; i++ ) {
		t = string[i];
		
		// I[
		if ( t == '\0' ) {
			break;
		}
		
		// r̉s
		if ( t == '\r' ) {
			if ( string[i + 1] == '\n' ) {
				i++;
				x = 0;
				dx = 0;
				y += 11;
				scroll_next();
				continue;
			}
		}
		
		// s
		if ( t == '\n' ) {
			x = 0;
			dx = 0;
			y += 11;
			scroll_next();
			continue;
		}
		
		// Shift-JIS  1 oCgڂꍇÃoCg𑫂ĂP`
		if ( (t >= 0x81 && t <= 0x9F) || (t >= 0xE0 && t <= 0xEF) || (t >= 0xF0 && t <= 0xFC) ) {
		
			if ( x + dx > 245 ) {
				x = 0;
				dx = 0;
				y += 11;
			}
			scroll_next();
			
			current = (t << 8) | string[i + 1];
			draw_font(x + dx, y, SCREEN_WIDTH, VRAM_A, current, color);
			i++;
			dx += 10;
		} else {
			if ( x + dx > 247 ) {
				x = 0;
				dx = 0;
				y += 11;
			}
			scroll_next();
			
			draw_font(x + dx, y, SCREEN_WIDTH, VRAM_A, t, color);
			dx += 6;
		}
		
	}
	y += 11;
}


void clear_screen() {
	int x, y;
	
	for ( x = 0; x < 256; x++ ) {
		for ( y = 0; y < 192; y++ ) {
			*(VRAM_A + x + y * SCREEN_WIDTH) = 0;
		}
	}
}
