#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "http.h"
#include "line_operation.h"


void separate_param(char *string, char **name, char **value);




// http_header \̂ւ̃蓖
struct http_header *alloc_http_header()
{
	struct http_header *temp;
	
	temp = malloc(sizeof(struct http_header));
	if ( temp == NULL ) {
		return NULL;
	}
	temp->name  = NULL;
	temp->value = NULL;
	temp->next  = NULL;
	
	return temp;
}

int free_http_header(struct http_header *header)
{
	struct http_header *temp;
	
	do {
		temp = header;
		header = header->next;
	
		if ( temp != NULL ) {
			free(temp->name);
			free(temp->value);
			free(temp);
		}
	} while ( header != NULL );
	
	return 0;
}

// http X|X̏
int parse_http(char *message, struct http_header** header/*, char **body*/)
{
	int index;
	char *line = NULL;
	struct http_header *current;
	struct line_state *ls;
	
	index = 0;
	current = NULL;
	
	ls = start_line_gets(message, NULL);
	line = line_gets(ls);
	
	while ( line != NULL ) {
		struct http_header *tmp;
		
		tmp = alloc_http_header();
		if ( tmp == NULL ) {
			end_line_gets(ls);
			return -1;
		}
		
		separate_param(line, &tmp->name, &tmp->value);
		
		if ( index == 0 ) {
			current = tmp;
			*header = tmp;
		} else {
			current->next = tmp;
			current = current->next;
		}
		index++;
		free(line);
		line = line_gets(ls);
		
		//iprintf("debug : \nname : %s\nvalue : %s\n", tmp->name, tmp->value);
		
		if ( strlen(line) == 0 ) {
			//*body = substr(message, line_get_next_index(ls), strlen(message));
			break;
		}
	}
	
	end_line_gets(ls);
	return 0;
}

// http_header \̂̒gʂɕ\
void print_header(struct http_header *header)
{
	struct http_header *cur;
	
	cur = header;
	
	iprintf("--- header ---\n");
	while ( 1 ) {
		if ( cur == NULL ) {
			break;
		}
		iprintf("name  : %s\nvalue : %s\n", cur->name, cur->value);
		cur = cur->next;
	}
	iprintf("--------------\n");
}

// http_header \̂p[^
char * find_header_value(struct http_header *header, char *name)
{
	struct http_header *cur;
	
	cur = header;
	
	while ( 1 ) {
		if ( cur == NULL ) {
			break;
		}
		
		if ( strcmp(cur->name, name) == 0 ) {
			return cur->value;
		}
		cur = cur->next;
	}
	return NULL;
}



// p[^𖼑Oƒlɕ
void separate_param(char *string, char **name, char **value)
{
	int i;
	int len;
	int index;
	char name_buf[1024];
	char value_buf[1024];
	char *result;
	int flag;
	
	len = strlen(string);
	index = 0;
	flag = 0;
	
	// 
	for ( i = 0; i < len && i < 1024; i++ ) {
		if ( flag == 0 ) {
			if ( string[i] == ':' ) {
				flag = 1;
				i++;
				name_buf[index] = '\0';
				index = 0;
				continue;
			}
			name_buf[index] = string[i];
		} else {
			value_buf[index] = string[i];
		}
		index++;
	}
	
	value_buf[index] = '\0';
	result = (char *)malloc(strlen(name_buf) + 1);
	if ( result == NULL ) {
		iprintf("malloc : error!\n");
		return;
	}
	strcpy(result, name_buf);
	*name = result;
	
	result = (char *)malloc(strlen(value_buf) + 1);
	if ( result == NULL ) {
		iprintf("malloc : error!\n");
		return;
	}
	strcpy(result, value_buf);
	*value = result;
	
	//iprintf("DEBUG : \n%d\nname  : %s\nvalue : %s\n", strlen(value_buf), *name, value_buf);
}

