#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "line_operation.h"


struct line_state * start_line_gets(char *string, char *delim)
{
	int i;
	int j;
	int len;
	char delimiter[4];
	struct line_state *line;
	struct line_list *list;
	struct line_list *current_list;
	
	if ( delim == NULL ) {
		delimiter[0] = '\r';
		delimiter[1] = '\n';
		delimiter[2] = '\0';
	} else {
		memset(delimiter, 0, 4);
		strncpy(delimiter, delim, 2);
	}
	
	len = strlen(string);
	i = 0;
	j = 0;
	
	line = malloc(sizeof(struct line_state));
	line->string = string;
	line->line = 0;
	line->end = 0;
	line->list = NULL;
	
	current_list = NULL;
	
	if ( line == NULL ) {
		return NULL;
	}
	
	//iprintf("start find\n");
	while ( j < strlen(string) || i < strlen(string) ) {
		line->end++;
		
		j = find_string(string, delimiter, i);
		
		list = malloc(sizeof(struct line_list));
		if ( list == NULL ) {
			return NULL;
		}
		
		list->start = i;
		list->end = j - strlen(delimiter);
		list->next = NULL;
		
		if ( line->list == NULL ) {
			current_list = list;
			line->list = current_list;
		} else {
			current_list->next = list;
			current_list = current_list->next;
		}
		
		if ( j < 0 ) {
			list->end = strlen(string);
			break;
		}
		
		i = j;
	}
	
	//iprintf("end start find\n");
	return line;
}

int end_line_gets(struct line_state *line)
{
	struct line_list *current;
	
	current = line->list;
	
	do {
		struct line_list *temp;
		temp = current;
		current = current->next;
		free(temp);
	} while ( current != NULL );
	
	free(line);
	
	return 0;
}


char * line_gets(struct line_state *line)
{
	int i;
	struct line_list *current;
	
	current = line->list;
	
	if ( line->line >= line->end ) {
		return NULL;
	}
	
	for ( i = 0; i < line->line; i++ ) {
		current = current->next;
	}
	line->line++;
	
	return substr(line->string, current->start, current->end);
}

int line_get_next_index(struct line_state *line)
{
	int i;
	struct line_list *current;
	
	current = line->list;
	
	if ( line->line >= line->end ) {
		return -1;
	}
	
	for ( i = 0; i < line->line; i++ ) {
		current = current->next;
	}
	
	return current->start;
}


int find_string(char *string, char *tofind, int start)
{
	int i;
	int j;
	int found;
	
	for ( i = start; i < strlen(string); i++ ) {
		if ( string[i] == tofind[0] ) {
			found = 0;
			for ( j = 0; j < strlen(tofind); j++ ) {
				if ( string[i + j] != tofind[j] ) {
					break;
				}
				found++;
			}
			if ( strlen(tofind) == found ) {
				return i + strlen(tofind);
				break;
			}
		}
	}
	
	return -1;
}

// E̋󔒂폜
char * trim(char *string)
{
	int i;
	int start;
	int end;
	
	start = 0;
	end   = strlen(string);
	
	for ( i = 0; i < strlen(string); i++ ) {
		if ( string[i] != ' ' ) {
			start = i;
			break;
		}
	}
	
	for ( i = strlen(string) - 1; i > 0; i-- ) {
		if ( string[i] == ' ' ) {
			end = i;
		} else {
			break;
		}
	}
	
	return substr(string, start, end);
}

char * substr(char *string, int start, int end)
{
	int i;
	int j;
	char * sub;
	
	j = 0;
	
	if ( start > end ) {
		return NULL;
	}
	sub = malloc(end - start + 1);
	if ( sub == NULL ) {
		return NULL;
	}

	if ( start > strlen(string) || end < 0 ) {
		return NULL;
	}

	for ( i = start; i < end; i++ ) {
		sub[j] = string[i];
		j++;
	}
	sub[j] = '\0';
	
	return sub;
}



// ̃TCYg
int expand_string(char **string, int alloc_size)
{
	char *tmp;
	char *old;
	
	tmp = malloc(alloc_size);
	
	if ( tmp == NULL ) {
		return -1;
	}
	
	strcpy(tmp, *string);
	old = *string;
	*string = tmp;
	free(old);
	
	return 0;
}

