#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include <nds.h>
#include <fat.h>
//#include <libfat.h>
#include <nds/arm9/cache.h>
#include <nds/arm9/console.h>



// WiFi Cu
#include <dswifi9.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#include "mplus_font_10x10.h"
#include "draw_font.h"
#include "line_operation.h"
#include "http.h"

#include "gba_nds_fat.h"
#include "disc_io.h"
#include "linkreset_arm9.h"
#include "_const.h"
#include "setarm9_reg_waitcr.h"
#include "../../ipcex.h"

extern void ret_menu9_R4(void); //====== R4TF was added. by Rudolph (2007/05/23)

//-----------------------------------------------------------------------------
// 萔̐錾

#define STR_MAX			256

//-----------------------------------------------------------------------------

// ݒt@C̕
char setting[3][STR_MAX];

// wifi timer function, to update internals of sgIP
void Timer_50ms(void) {
	Wifi_Timer(12);
}

// notification function to send fifo message to arm7
void arm9_synctoarm7() { // send fifo message
	REG_IPC_FIFO_TX = 0x87654321;
}

// interrupt handler to receive fifo messages from arm7
void arm9_fifo() { // check incoming fifo messages
	u32 value = REG_IPC_FIFO_RX;
	if ( value == 0x87654321 ) {
		Wifi_Sync();
	}
}


void init_wifi() {
	// ARM7 WiFi ̂߂ FIFO bZ[W̑M
	REG_IPC_FIFO_CR = IPC_FIFO_ENABLE | IPC_FIFO_SEND_CLEAR; // FIFO LNA

	u32 Wifi_pass= Wifi_Init(WIFIINIT_OPTION_USELED);
	REG_IPC_FIFO_TX = 0x12345678;
	REG_IPC_FIFO_TX = Wifi_pass;

	*((volatile u16 *)0x0400010E) = 0; // Timer3 
	
	irqSet(IRQ_TIMER3, Timer_50ms); // Timer IRQ ̃ZbgAbv
	irqEnable(IRQ_TIMER3);
	irqSet(IRQ_FIFO_NOT_EMPTY, arm9_fifo); // FIFO IRQ ̃ZbgAbv
	irqEnable(IRQ_FIFO_NOT_EMPTY);

	REG_IPC_FIFO_CR = IPC_FIFO_ENABLE | IPC_FIFO_RECV_IRQ; // FIFO IRQ L

	Wifi_SetSyncHandler(arm9_synctoarm7); // tell wifi lib to use our handler to notify arm7

	// Timer3 ̃Zbg
	TIMER3_DATA = -1638; // 6553.1 * 256 cycles = ~50ms;
	TIMER3_CR = 0x00C2; // enable, irq, 1/256 clock
	
	// wait for arm7 to be initted successfully
	while ( Wifi_CheckInit() == 0 ) {
		//while(VCOUNT < 262){;}
		//while(VCOUNT != 0){;}
		swiWaitForVBlank();
	}
}

void print_local_ip_addr()
{
	char buf[512];
	u32 ip_addr = Wifi_GetIP();
	
	sprintf((char *)buf,"Local IP : %i.%i.%i.%i\n", (int)((ip_addr)&255),(int)((ip_addr>>8)&255),(int)((ip_addr>>16)&255),(int)((ip_addr>>24)&255));
	echo(buf);
	//iprintf("%s\n", (char *)buf);
}



struct hostent * resolv_host(char *server)
{
	int i;
	struct hostent *host;
	
	host = gethostbyname(server);
	
	if ( !host ) {
		echo("ڑzXgs");
		return NULL;
	} else {
		int lng;
		echo("ڑzXg");
		
		for ( i = 0; i < 5; i++ ) {
			if ( host->h_addr_list[i] ) {
				lng = *((unsigned long *) host->h_addr_list[i]);
				//iprintf("Address %i: %i.%i.%i.%i\n",i+1,(int)((lng)&255),(int)((lng>>8)&255),(int)((lng>>16)&255),(int)((lng>>24)&255));
			} else {
				break;
			}
		}
	}
	
	return host;
}

int open_tcp_socket()
{
	int sock;
	sock = socket(AF_INET, SOCK_STREAM, 0);
	if ( sock < 0 ) {
		iprintf("socket error \n");
		return 0;
	}
	
	return sock;
}

int connect_start(int sock, struct hostent * host, int port)
{
	int result;
	struct sockaddr_in sockin;

	sockin.sin_family = AF_INET;
	sockin.sin_addr.s_addr = *((unsigned long *)(host->h_addr_list[0]));
	sockin.sin_port = htons(port);
	
	result = connect(sock, (struct sockaddr *)&sockin, sizeof(sockin));
	
	if ( result < 0 ) {
		echo("\\PbgڑG[");
		return -1;
	}
	
	return 0;
}

int send_data(int sock, char *server, char *url)
{
	char get_method[1024];
	
	sprintf(get_method, "GET %s HTTP/1.1\r\nHost: %s\r\n\r\n", url, server);
	send(sock, get_method, strlen(get_method), 0);
	echo("GET NGXgM");
	
	return 0;
}

int recv_data(int sock)
{
	const int RECV_BUF_SIZE = 8192;
	char filepath[STR_MAX + 8];
	
	FILE* file;
	char *buf;
	int flag_data_start = 0;
	int sn = 0;
	int http_header_size = 0;
	int i;
	int size_of_received = 0;
	int size_of_file = 0;
	int count = 0;
	char tcp_temp[RECV_BUF_SIZE + 1];
	char *tmp;
	char *separator = "\r\n\r\n";
	
	buf = (char *)malloc(RECV_BUF_SIZE * 2);
	
	if ( buf == NULL ) {
		echo("AP[VG[");
		return -1;
	}
	
	filepath[0] = '\0';
	strcat(filepath, "fat0:/");
	strcat(filepath, setting[2]);
	//echo(filepath);
	file = fopen(filepath, "w");
	
	if ( file == NULL ) {
		echo("t@CI[vG[");
		return -1;
	}
	
	echo("MJn - (B {^ŃXgbv܂)");
	iprintf("\x1b[2;0HReceived / Total");
	
	for ( ;; ) {
		// B{^ꂽ~
		scanKeys();
		if ( keysDown() & KEY_B ) {
			echo("~܂");
			break;
		}
	
		i = recv(sock, tcp_temp, RECV_BUF_SIZE, 0);
		tmp = tcp_temp;
		
		if ( i == -1 ) {
			echo("MG[");
			return -1;
			break;
		}
		
		// connection closed
		if ( i == 0 ) {
			echo("MI");
			break;
		}
		
		size_of_received += i;
		
		if ( flag_data_start == 1 ) {
			fwrite(tmp, sizeof(char), i, file);
			//iprintf("#");
			if (count % 3 == 0) {
				iprintf("\x1b[3;0H%d / %d", size_of_received - http_header_size, size_of_file);
				count = 0;
			}
			count++;
		} else {
			int find_pos;
			char *find_str;
			
			sn = 0;
			while ( i > 0 ) {
				*(buf + sn) = *tmp;
				tmp++;
				sn++;
				i--;
			}
			*(buf + sn) = '\0';
			find_pos = find_string(buf, separator, 0);
			if ( find_pos != -1 ) {
				struct http_header *header;
				char *content_length;
				char temp[512];
				
				header = alloc_http_header();
				parse_http(buf, &header);
				content_length = find_header_value(header, "Content-Length");
				free_http_header(header);
				
				if ( content_length != NULL ) {
					sprintf(temp, "File Size : %s Bytes", content_length);
					echo(temp);
					size_of_file = atoi(content_length);
				} else {
					echo("t@CTCYs");
				}
			
				find_str = substr(buf, find_pos, sn);
				fwrite(find_str, sizeof(char), sn - find_pos, file);
				free(find_str);
				flag_data_start = 1;
				
				http_header_size = find_pos;
			}
		}
			
		if (size_of_received - http_header_size == size_of_file) {
			echo("MI");
			break;
		}
	}
	iprintf("\x1b[3;0H%d / %d", size_of_received - http_header_size, size_of_file);
	
	free(buf);
	fclose(file);
	fatUnmount(PI_DEFAULT);
	
	return 0;
}

int do_play_tcp_connect(char *server, char *url)
{
	struct hostent * host;
	int sock = 0;
	
	host = resolv_host(server);
	if ( host == NULL ) {
		return -1;
	}
	sock = open_tcp_socket();
	if ( sock == 0 ) {
		return -1;
	}
	if ( connect_start(sock, host, 80) < 0 ) {
		return -1;
	}
	
	echo("\\PbgJ܂\n");
	
	send_data(sock, server, url);
	if ( recv_data(sock) == -1 ) {
		return -1;
	}
	
	closesocket(sock);
	echo("\\Pbg܂\n");
	
	return 0;
}



//-----------------------------------------------------------------------------


int wifi_auto_connect() {
	
	int i;
	int count = 0;
	int flag = 0;
	
	iprintf("\x1b[0;0HSearching ...");
	
	// request connect
	Wifi_AutoConnect();
	while ( 1 ) {
		// check status
		i = Wifi_AssocStatus();
		if ( i == ASSOCSTATUS_ASSOCIATED ) {
			return 0;
			break;
		}
		if ( i == ASSOCSTATUS_CANNOTCONNECT ) {
			return -1;
			break;
		}
		if ( i == ASSOCSTATUS_SEARCHING ) {
			if (flag == 0) {
				flag = 1;
				iprintf("\x1b[0;15H*");
			} else {
				flag = 0;
				iprintf("\x1b[0;15H ");
			}
		}
		
		for ( count = 0; count < 60; count++ )
			swiWaitForVBlank();
	}
	iprintf("\n");
}

//====== R4TF was added.
static void _boot_VRAM_clear()
{
/*********
	u16 _VRAM_C_CR=VRAM_C_CR;
	u16 _VRAM_D_CR=VRAM_D_CR;

	VRAM_C_CR = VRAM_ENABLE | (1 | 0);
	VRAM_D_CR = VRAM_ENABLE | (1 | (1<<3));

	memset((char*)0x06000000, 0x00, 0x40000);

	VRAM_C_CR=_VRAM_C_CR;
	VRAM_D_CR=_VRAM_D_CR;
*********/

/* ꎞIɕ\Ƃ̂݃NA */
	u16	*vr;
	int	i;

	u16 _VRAM_C_CR=VRAM_C_CR;

	VRAM_C_CR = VRAM_ENABLE | VRAM_C_MAIN_BG_0x06000000;

	vr = (u16*)0x06010000;
	for(i = 0; i < 0x10000/2; i++) {
		*vr = 0x0000;
		vr++;
	}

	VRAM_C_CR=_VRAM_C_CR;

}

void on_irq_main() 
{	
	//if(REG_IF & IRQ_VBLANK) {
		// Handle vertical blank interrupt
		VBLANK_INTR_WAIT_FLAGS |= IRQ_VBLANK;
		REG_IF |= IRQ_VBLANK;
	//}
	//else {
		// Ignore all other interrupts
		//REG_IF = REG_IF;
	//}
}



void SoftReset(void)
{
	if(FAT_InitFiles() == false) {
		iprintf("Can not initialized FAT.\n");
		while(1);
	}
	FAT_FILE *r4 = FAT_fopen("/_DS_MENU.DAT", "rb");
	(*(vu32*)0x027FFE18) = r4->dirEntSector*512+r4->dirEntOffset*32;
	FAT_fclose(r4);
	//iprintf("_DS_MENU.DAT = %08X\n", *(vu32*)0x027FFE18);

	_boot_VRAM_clear();

	//RESET=RESET_MENU_R4TF;
	IPCEX->RESET=RESET_MENU_R4TF;//RESET;

	REG_IME = 0;
	REG_IE = 0;
	REG_IF = REG_IF;

	REG_EXMEMCNT = 0xE880;
	//WAIT_CR = 0xE880;
	REG_IPC_SYNC = 0;
	DMA0_CR = 0;
	DMA1_CR = 0;
	DMA2_CR = 0;

	ret_menu9_R4();
	while(1);
}

void chomp(char *str)
{
	int last = strlen(str) - 1;
	int i;
	
	for (i = last; i > last - 3; i--)
	{
		if (*(str + i) == '\n' || *(str + i) == 0x0D)
			*(str + i) = '\0';
	}
}

// C[`
int main(void)
{
	char message[512];
	int result;
	
	powerON(POWER_ALL);
	videoSetMode(MODE_FB0);
	videoSetModeSub(MODE_0_2D | DISPLAY_BG0_ACTIVE);
	
	vramSetBankA(VRAM_A_LCD);
	vramSetBankC(VRAM_C_SUB_BG);
	
	SUB_BG0_CR = BG_MAP_BASE(31);
	BG_PALETTE_SUB[255] = RGB15(31,31,31);
	consoleInitDefault((u16*)SCREEN_BASE_BLOCK_SUB(31), (u16*)CHAR_BASE_BLOCK_SUB(0), 16);
	
	echo("------------------------------------------");
	echo("# DS t@C_E[_ Ver 0.3.1");
	echo("------------------------------------------");
	
	lcdSwap();
	
	irqInit();
	// V-Blank荞ݏo^
	irqSet(IRQ_VBLANK, on_irq_main);
	irqEnable(IRQ_VBLANK);
	
	
	// fat
	if ( fatInitDefault() == FALSE ) {
		echo("t@CVXeG[");
		echo("DLDIhCoĂȂ\\܂");
		return -1;
	}
	fatMountNormalInterface(PI_DEFAULT, 0x8000);
	
	// ݒt@Cǂݍ
	echo("ݒt@Cǂݍ݊Jn");
	{
		FILE* file;
		file = fopen("fat0:/downloader.txt", "r");
		
		if (!file) {
			echo("ݒt@CJ܂");
			echo("/downloader.txt Ă");
			while(1) {
				swiWaitForVBlank();
			}
		}
		
		fgets(setting[0], STR_MAX, file);
		chomp(setting[0]);

		fgets(setting[1], STR_MAX, file);
		chomp(setting[1]);

		fgets(setting[2], STR_MAX, file);
		chomp(setting[2]);
		
		if (strlen(setting[2]) == 0)
			strcpy(setting[2], "download.nds");
		
		fclose(file);
	}
	echo("ݒt@Cǂݍ݊");
	echo("");
	
	echo("E_E[h URL");
	sprintf(message, "http://%s%s", setting[0], setting[1]);
	echo(message);
	echo("Eۑt@C");
	echo(setting[2]);
	echo("------------------------------------------");
	
	// wifi
	init_wifi();
	
	echo("Wi-Fi ڑJn");
	
	if ( wifi_auto_connect() == 0 ) {
		echo("Wi-Fi ڑ");
	} else {
		echo("Wi-Fi ڑs");
		while(1) {
			swiWaitForVBlank();
		}
	}
	
	print_local_ip_addr();
	
	echo("_E[hJn");
	
	result = do_play_tcp_connect(setting[0], setting[1]);
	
	if (result == 0)
		echo("_E[hI - (A {^ŃZbg܂)");
	else
		echo("G[ - (A {^ŃZbg܂)");
	
	Wifi_DisconnectAP();
	Wifi_DisableWifi();
	
	scanKeys();
	swiWaitForVBlank();
	scanKeys();
	
	while (1) {
		swiWaitForVBlank();
		// A{^ꂽ~
		scanKeys();
		if ( (keysDown() & KEY_A) || (keysDown() & KEY_TOUCH) ) {
			echo("Zbg܂");
			SetARM9_REG_WaitCR();
			SoftReset();
			break;
		}
	}
	return 0;
}

